/*
 * Experimental Connected Vehicle API
 * An experimental Connected Vehicle API that allows to request vehicle data and to send commands to the virtual car simulator.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.DoorLockChangeRequestBody;
import io.swagger.client.model.DoorLockChangedStatus;
import io.swagger.client.model.Doors;
import io.swagger.client.model.ErrorResponse;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class DoorsApi {
    private ApiClient apiClient;

    public DoorsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public DoorsApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getDoorsStatus
     * @param vehicleId ID of vehicle to return. (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getDoorsStatusCall(String vehicleId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/vehicles/{vehicleId}/doors"
            .replaceAll("\\{" + "vehicleId" + "\\}", apiClient.escapeString(vehicleId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getDoorsStatusValidateBeforeCall(String vehicleId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'vehicleId' is set
        if (vehicleId == null) {
            throw new ApiException("Missing the required parameter 'vehicleId' when calling getDoorsStatus(Async)");
        }
        

        com.squareup.okhttp.Call call = getDoorsStatusCall(vehicleId, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get the status of all doors of the vehicle.
     * Returns status of all doors of the vehicle. It informs about each door if it is locked, unlocked, open or closed.
     * @param vehicleId ID of vehicle to return. (required)
     * @return Doors
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Doors getDoorsStatus(String vehicleId) throws ApiException {
        ApiResponse<Doors> resp = getDoorsStatusWithHttpInfo(vehicleId);
        return resp.getData();
    }

    /**
     * Get the status of all doors of the vehicle.
     * Returns status of all doors of the vehicle. It informs about each door if it is locked, unlocked, open or closed.
     * @param vehicleId ID of vehicle to return. (required)
     * @return ApiResponse&lt;Doors&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Doors> getDoorsStatusWithHttpInfo(String vehicleId) throws ApiException {
        com.squareup.okhttp.Call call = getDoorsStatusValidateBeforeCall(vehicleId, null, null);
        Type localVarReturnType = new TypeToken<Doors>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get the status of all doors of the vehicle. (asynchronously)
     * Returns status of all doors of the vehicle. It informs about each door if it is locked, unlocked, open or closed.
     * @param vehicleId ID of vehicle to return. (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getDoorsStatusAsync(String vehicleId, final ApiCallback<Doors> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getDoorsStatusValidateBeforeCall(vehicleId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Doors>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for postDoors
     * @param vehicleId ID of vehicle to return. (required)
     * @param body JSON object containing the command to lock or unlock the doors. (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call postDoorsCall(String vehicleId, DoorLockChangeRequestBody body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/vehicles/{vehicleId}/doors"
            .replaceAll("\\{" + "vehicleId" + "\\}", apiClient.escapeString(vehicleId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call postDoorsValidateBeforeCall(String vehicleId, DoorLockChangeRequestBody body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'vehicleId' is set
        if (vehicleId == null) {
            throw new ApiException("Missing the required parameter 'vehicleId' when calling postDoors(Async)");
        }
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling postDoors(Async)");
        }
        

        com.squareup.okhttp.Call call = postDoorsCall(vehicleId, body, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Locks or unlocks all doors of the vehicle.
     * Locks or unlocks all doors of the vehicle.
     * @param vehicleId ID of vehicle to return. (required)
     * @param body JSON object containing the command to lock or unlock the doors. (required)
     * @return DoorLockChangedStatus
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public DoorLockChangedStatus postDoors(String vehicleId, DoorLockChangeRequestBody body) throws ApiException {
        ApiResponse<DoorLockChangedStatus> resp = postDoorsWithHttpInfo(vehicleId, body);
        return resp.getData();
    }

    /**
     * Locks or unlocks all doors of the vehicle.
     * Locks or unlocks all doors of the vehicle.
     * @param vehicleId ID of vehicle to return. (required)
     * @param body JSON object containing the command to lock or unlock the doors. (required)
     * @return ApiResponse&lt;DoorLockChangedStatus&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<DoorLockChangedStatus> postDoorsWithHttpInfo(String vehicleId, DoorLockChangeRequestBody body) throws ApiException {
        com.squareup.okhttp.Call call = postDoorsValidateBeforeCall(vehicleId, body, null, null);
        Type localVarReturnType = new TypeToken<DoorLockChangedStatus>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Locks or unlocks all doors of the vehicle. (asynchronously)
     * Locks or unlocks all doors of the vehicle.
     * @param vehicleId ID of vehicle to return. (required)
     * @param body JSON object containing the command to lock or unlock the doors. (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call postDoorsAsync(String vehicleId, DoorLockChangeRequestBody body, final ApiCallback<DoorLockChangedStatus> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = postDoorsValidateBeforeCall(vehicleId, body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<DoorLockChangedStatus>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
